import { BaseItemAnimator } from "../../../core/ItemAnimator";
/**
 * This animator prevents views from shifting up/down.
 * This is stateful and thus, will work once per mount. Make sure you pass a new instance for every
 * new RLV mount.
 */
export declare class LayoutStabilizerAnimator extends BaseItemAnimator {
    private _isQueueComplete;
    private _stabilizationInProgress;
    private _stabilizationComplete;
    private _lastProcessingTS;
    private _indexBounds;
    private _viewCache?;
    private readonly _numberOfFramesToBatch;
    constructor(numberOfFramesToBatch?: number);
    shouldPersistStyleOverrides(): boolean;
    animateWillMount(atX: number, atY: number, itemIndex: number): object | undefined;
    animateDidMount(atX: number, atY: number, itemRef: object, itemIndex: number): void;
    animateWillUpdate(fromX: number, fromY: number, toX: number, toY: number, itemRef: object, itemIndex: number): void;
    animateShift(fromX: number, fromY: number, toX: number, toY: number, itemRef: object, itemIndex: number): boolean;
    animateWillUnmount(atX: number, atY: number, itemRef: object, itemIndex: number): void;
    private _checkForMovementAndStabilize;
    private _startStabilization;
    private _completeStabilization;
    private _hasStabilizationStartedOrComplete;
    private _isStabilizationComplete;
    private _unHideViews;
}
