"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var RAFToken = /** @class */ (function () {
    function RAFToken() {
        this._isTerminated = false;
    }
    RAFToken.prototype.terminate = function () {
        this._isTerminated = true;
    };
    RAFToken.prototype.isTerminated = function () {
        return this._isTerminated;
    };
    return RAFToken;
}());
exports.RAFToken = RAFToken;
var RAFHelper = /** @class */ (function () {
    function RAFHelper() {
    }
    RAFHelper.executeOnRAF = function (func, rafNesting) {
        var rAFExecutable = function (tokenValue) {
            func(tokenValue);
            if (!tokenValue.isTerminated()) {
                rAFExecutable(tokenValue);
            }
        };
        var _loop_1 = function (i) {
            var methodRef = rAFExecutable;
            rAFExecutable = function (tokenValue) {
                requestAnimationFrame(function () {
                    methodRef(tokenValue);
                });
            };
        };
        for (var i = 0; i < rafNesting; i++) {
            _loop_1(i);
        }
        var token = new RAFToken();
        rAFExecutable(token);
    };
    return RAFHelper;
}());
exports.RAFHelper = RAFHelper;
//# sourceMappingURL=RAFHelper.js.map